import { CaseConvention } from './case'
import { deserialize } from './de'
import { Serde, serde } from './decorator'
import { fromString, toString } from './json'
import { serialize } from './ser'

const InnerStruct = deserialize(serialize(
  class {
    c = 'awawa'
  }))

const TestStruct = deserialize(serialize(
  serde({ renameAll: CaseConvention.PascalCase })(
    class {
      a = 1
      b
      inner = new InnerStruct()
      d = true
      e = Math.pow(2, 53)
      f = Symbol('test')
      g = [1, 'a', [3]]

      constructor() {
        this.b = new Map()
        this.b.set('test key', 2)
      }
    })))

const test = new TestStruct()
console.log(test)
const value = toString(test)
console.log('A', value)
const test2 = fromString(value, TestStruct)
console.log(test2)



